 /*
 *  file      : poche.h
 *  project   : zoomc
 *  with      : Gtk-2
 *
 *  copyright : (C) 2010 - 2011 by Claude Bulin
 *
 *  ZOOMC - GTK+ implementation of the GNU shell command
 *  GNU General Public License
 *
 *  This file is part of ZOOMC.
 * 
 *  ZOOMC is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  at your option) any later version.
 * 
 *  ZOOMC is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with ZOOMC.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __poche_h__
#define __poche_h__ 1

#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gi18n.h>


//
// POCHE_xx
//
typedef struct {
								// UNE STRUCTURE PAR FICHIER IMAGE
	gchar		*name_img;				// Nom du fichier image original
	gchar		*name_png;				// Nom du fichier PNG
	GtkWidget	*togglebutton;				// Adresse du bouton
	GtkWidget	*image;					// Adresse de l'image
	GtkWidget	*label;					// Adresse du label
	
} GLIST_POCHETTE;

typedef enum {
	IMG_HAUT_GAUCHE,					// 
	IMG_HAUT,						// 
	IMG_HAUT_DROIT,						// 
	IMG_DROIT,						// 
	IMG_BAS_DROIT,						// 
	IMG_BAS,						// 
	IMG_BAS_GAUCHE,						// 
	IMG_GAUCHE,						// 
	IMG_MOVE,						// 
	IMG_SIZE,						// For size tab HANDLE_MOVE [][]
	IMG_NONE						// NO IMAGE SELECTED
} IMG_CORNER;

typedef struct {

	GdkRectangle	zone[ IMG_SIZE ];			// Les IMG_SIZE coordonnees de saisie de l'image
								// EX:
								// 	zone [ IMG_HAUT ] . x
								// 	zone [ IMG_HAUT ] . y
								// 	zone [ IMG_HAUT ] . width
								// 	zone [ IMG_HAUT ] . height
} HANDLE_MOVE;

typedef struct {
	GdkPixbuf	*Pixbuf;				// Adresse du PixBuf en traitement
	GdkPixbuf	*PixbufOriginal;			// Adresse du PixBuf original
	cairo_surface_t	*image;					// Adresse de l'image
	gdouble		x0;					// Pos X
	gdouble		y0;					// Pos Y
	gint		image_width;				// Width
	gint		image_height;				// Height
	gdouble		XPointer;				// Position x de la souris lors du clic
	gdouble		YPointer;				// Position y de la souris lors du clic
	gboolean	BoolIsSelected;				// TRUE = selected with mouse cursor
	gboolean	BoolStructActived;			// TRUE = ACTIVE | FALSE = STRUCT IS REMOVE
} IMAGE;

typedef struct {
	GtkWidget	*AdrDrawingarea;			// Adresse de la surface
	gboolean	BoolScaleAdjust;			// TRUE = ajustement de l'echelle avec la surface de la fentre
	cairo_surface_t	*image;					// Adresse de l'image
	gdouble		scale;					// Pourcentage de surface de l'image
	gdouble		x0;					// Pos X
	gdouble		y0;					// Pos Y
	gint		image_width;				// Width
	gint		image_height;				// Height
	GList		*ListImage;				// Liste des image dans 'Adr_viewport_image_preview'
	gboolean	BoolEventButtonPress;			// TRUE == BOUTON SOURIS PRESSED
	IMAGE		*GetImage;				// Adresse de l'image en selection
	IMG_CORNER	ImgCorner;				// See IMG_CORNER
	GtkWidget	*Adr_viewport_image_preview;		// Adresse viewport
	GtkWidget	*Adr_table;				// Adresse table contenu dans le viewport
	GList		*glist;					// Contient les structures GLIST_POCHETTE
	HANDLE_MOVE	HandleMove;				// Les coordonnees de saisie de l'image
} VIEW;

extern	VIEW view;

IMAGE  *poche_add_to_glist( gchar *PathNameFile, gdouble x, gdouble y, gboolean p_BoolScale, gboolean p_BoolSelected );
void	poche_set_selected_image( IMAGE *p_Image );
void	pochedir_add_img_file( GSList *p_list );
void	poche_add_img_file( GSList *p_list );

#endif

